
class Segment {

  public Number3D offset;
  public Number3D axis;
  public Number3D control;

  public Number3D storedOffset;
  public Number3D storedAxis;
  public Number3D storedControl;

  public int seed;

  public float angle;

  public int totalLines = 50;

  public Number3D[] orbit = new Number3D[totalLines];

  color from = color(255, 0, 102);
  color to = color(0, 102, 153);
  public Segment() {

    reset();
  }

  public void reset() {


    int radius = 100;

    axis 	= new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );
    offset 	= new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );
    control     = new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );

    /*
		int radiusA = 50;
     		int radiusB = 100;
     
     		offset 	= new Number3D( 0,0,0 );
     		axis 	= new Number3D( random(radiusA), random(radiusA),	random(radiusA) );
     		control = new Number3D( random(radiusB), random(radiusB),	random(radiusB) );
     		*/

    // axis 	= new Number3D( 50, 0, 0 );
    // offset 	= new Number3D( 0, 0, 0 );
    // control = new Number3D( 0, random(radius)+25, 0 );



    storedAxis = copyFrom2(axis);
    storedOffset = copyFrom2(offset);
    storedControl = copyFrom2(control);
    // angle 	= float(random(360)); 	// in degrees
  }

  public void parse() {
    for(int i=0;i<totalLines;i++) {
      angle = 360*float(i)/float(totalLines) + frameCount*(seed+1)*.125;
      // angle = 360*float(i)/float(totalLines);
      orbit[i] = rotateAroundArbitraryAxis( offset, control, axis, angle );
    }
  }

  public void draw() {

    drawWidthArray(orbit,#FFFFFF);
    // drawPoint(axis,2,#FFFFFF);
    // drawLine(axis,offset,1,#FFFFFF);
  }

  void drawWidthArray(Number3D[] orbiter, color colorParam) {


    Number3D curr = new Number3D(0,0,0);
    Number3D prev = new Number3D(0,0,0);  
    int lines = orbiter.length;
    float percentage;
    strokeWeight(1);
    float colorShifter = sin( ((float(seed) / float(totalSegments) + frameCount*.001) * TWO_PI))*.5+.5;
    color interColor = lerpColor(from, to,  colorShifter);
    
    for(int i=1;i<lines;i++) {
      curr.copyFrom(orbiter[i]);
      prev.copyFrom(orbiter[i-1]);

      percentage = (float(i)/float(lines)) * 255;

      noStroke();
      fill(interColor, percentage);
      beginShape(TRIANGLE_FAN);
      vertex(prev.x,prev.y,prev.z);
      vertex(curr.x,curr.y,curr.z);
      vertex(offset.x,offset.y,offset.z);
      vertex(prev.x,prev.y,prev.z);
      endShape();



      // stroke(#FF0000,51);
      // line(0,0,0, curr.x,curr.y,curr.z);
    }
  }

  public void drawPoint(Number3D pointParam, int strokeParam, color colorParam) {
    strokeWeight(strokeParam);
    stroke(colorParam,255);
    point( pointParam.x,pointParam.y,pointParam.z);
  }

  public void drawLine(Number3D pointAParam,Number3D pointBParam, int strokeParam, color colorParam) {
    strokeWeight(strokeParam);
    stroke(colorParam,102);
    line( pointAParam.x,pointAParam.y,pointAParam.z,pointBParam.x,pointBParam.y,pointBParam.z);
  }
}

