import processing.core.*; 
import processing.xml.*; 

import processing.opengl.*; 
import peasy.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Umbrella extends PApplet {





PeasyCam cam;

float axis_X = 0;
float axis_Y = 50;
float axis_Z = 0;

float control_X = 100;
float control_Y = 100;
float control_Z = 0;

float offset_X = 0;
float offset_Y = 100;
float offset_Z = 0;

int totalSegments = 40;

Number3D[] orbit = new Number3D[totalSegments];
Segment[] segments = new Segment[totalSegments];

public void setup() {
 size(1200,800,OPENGL); 
  
	cam = new PeasyCam(this, 1000);
	cam.setMinimumDistance(50);
	cam.setMaximumDistance(2000);
	
	
	    // --------------------------------------------------------------------
    // parse data
    // --------------------------------------------------------------------
    int offset;
    int id = 0;
    float absMax = 100;

    offset = 10;

	for(int i=0;i<totalSegments;i++){
		segments[i] = new Segment();
		segments[i].seed = i;
	}
	
}
public void draw() {
	
	background(0);
	
	drawAxes(400);
	
	// --------------------------------------------------------------------
	// draw base 
	// --------------------------------------------------------------------
	background(0);
	// drawAxes(400);
	Number3D sumOffset = new Number3D(0,0,0);
	Number3D sumAxis = new Number3D(0,0,0);
	float angleX,angleY;
	
	int i,j,k;
	float percentage;

	segments[0].offset = new Number3D(offset_X,offset_Y,offset_Z);
	segments[0].axis = new Number3D(axis_X,axis_Y,axis_Z);
	
	sumOffset = segments[0].offset;
	sumAxis = segments[0].axis;
	segments[0].parse();

	for(i=1;i<totalSegments;i++){
		
		segments[i].offset = copyFrom2(segments[i-1].axis);
		segments[i].control = add2(segments[i].storedControl, segments[i].offset);
		segments[i].axis = add2(segments[i].storedAxis, segments[i].offset);
		
		angleX = frameCount*(1-PApplet.parseFloat(i)/PApplet.parseFloat(totalSegments));
		angleY = frameCount*(PApplet.parseFloat(i)/PApplet.parseFloat(totalSegments)); 
		
		segments[i].axis = rotateAroundYAxis(segments[i].offset,segments[i].axis,angleX);
		segments[i].axis = rotateAroundXAxis(segments[i].offset,segments[i].axis,angleY);
		
		segments[i].parse();
		segments[i].draw();

	}
	
	/*
	strokeWeight(1);
	for(i=0;i<segments[0].totalLines;i++){
		for(j=1;j<totalSegments;j++){
			
			percentage = (1-float(i+1)/float(30)) * 255;
			drawLine( segments[j].orbit[i] ,segments[j-1].orbit[i], 1, #FFFFFF ,percentage);
		}
	
	}
*/
	
	
	// --------------------------------------------------------------------
	// parse data
	// --------------------------------------------------------------------
	
	// --------------------------------------------------------------------
	// draw data
	// --------------------------------------------------------------------
	
	noFill();

}
public void drawLine(Number3D pointAParam,Number3D pointBParam, int strokeParam, int colorParam, float alphaParam){
	strokeWeight(strokeParam);
	stroke(colorParam,alphaParam);
	line( pointAParam.x,pointAParam.y,pointAParam.z ,pointBParam.x,pointBParam.y,pointBParam.z);
}

public void drawAxes(float radius) {
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0,255);
  line(0, 0, 0, radius, 0, 0);
  stroke(0, 255, 0,255);
  line(0, 0, 0, 0, radius, 0);
  stroke(0, 0, 255,255);
  line(0, 0, 0, 0, 0, radius);

  stroke(0xff00FF00,51);
  pushMatrix();
  translate(0, radius,0);
  box(10);
  popMatrix();             

  stroke(0xffFF0000,51);
  pushMatrix();
  translate(radius, 0,0);
  box(10);
  popMatrix(); 

  stroke(0xff0000FF,51);
  pushMatrix();
  translate(0, 0,radius);
  box(10);
  popMatrix(); 

  stroke(0xffFFFFFF,51);
  ellipse(0, 0, 200, 200);

  stroke(0xffFFFFFF,51);
  box(radius*2);
}

public Number3D sub2(Number3D v, Number3D w) {
  return new Number3D(  (v.x - w.x), (v.y - w.y), (v.z - w.z));
}

public Number3D add2(Number3D v, Number3D w) {
  return new Number3D(  (v.x + w.x), (v.y + w.y), (v.z + w.z));
}

public Number3D invert2(Number3D v) {
  return new Number3D( -v.x, -v.y, -v.z);
}


public Number3D copyFrom2(Number3D v) {
  return new Number3D( v.x, v.y, v.z);
}

public Number3D normalize2(Number3D v) {
  float m  = sqrt((v.x * v.x) + (v.y * v.y) + (v.z * v.z));
  return new Number3D( v.x/m, v.y/m, v.z/m );
}

/**
 * @param offsetParam Translation offset of axis
 * @param controlParam Regulates size and scale of radius
 * @param axisParam Regulates orientation rotation
 * @param angle Amount rotated
 **/
public Number3D rotateAroundArbitraryAxis(Number3D offsetParam,Number3D controlParam,Number3D axisParam,float angle) {
  Number3D control = copyFrom2(controlParam);
  Number3D axis = copyFrom2(axisParam);
  Number3D offset = copyFrom2(offsetParam);

  control.sub(offset);
  axis.sub(offset);
  axis.normalize(axis);

  float rads = PI/180 * angle;                       
  float sinTheta = sin(rads*.5f);
  float cosTheta = cos(rads*.5f);

  Quaternion rotQuat   = new Quaternion(  cosTheta,  
  sinTheta * axis.x,  
  sinTheta * axis.y,  
  sinTheta * axis.z );
  Quaternion pointQuat = new Quaternion(  0,
  control.x,
  control.y,
  control.z );
  Quaternion conjQuat  = new Quaternion(  rotQuat.a,
  -rotQuat.b,
  -rotQuat.c,
  -rotQuat.d );

  Quaternion temp = quat_mult(rotQuat,pointQuat);
  Number3D result = quat_pointmult(temp,conjQuat);
  result.add(offset);
  return result;
}

public Number3D rotateAroundZAxis(Number3D offset, Number3D controlParam, float angle) {

  Number3D control = copyFrom2(controlParam);
  control.sub(offset);

  float rads = PI/180 * angle;
  float cosTheta = cos(rads);
  float sinTheta = sin(rads);

  float x = cosTheta*control.x + sinTheta*control.y;
  float y = -sinTheta*control.x + cosTheta*control.y;
  float z = control.z;

  Number3D result = new Number3D(x,y,z);
  result.add(offset);

  return result;
}

public Number3D rotateAroundYAxis(Number3D offset, Number3D controlParam, float angle) {
  Number3D control = copyFrom2(controlParam);
  control.sub(offset);

  float rads = PI/180 * angle;
  float cosTheta = cos(rads);
  float sinTheta = sin(rads);

  float x = cosTheta*control.x - sinTheta*control.z;
  float y = control.y;
  float z = sinTheta*control.x + cosTheta*control.z;

  Number3D result = new Number3D(x,y,z);

  result.add(offset);

  return result;
}

public Number3D rotateAroundXAxis(Number3D offset, Number3D controlParam, float angle) {
  Number3D control = copyFrom2(controlParam);
  control.sub(offset);

  float rads = PI/180 * angle;
  float cosTheta = cos(rads);
  float sinTheta = sin(rads);

  float x = control.x;
  float y = cosTheta*control.y + sinTheta*control.z;
  float z = -sinTheta*control.y + cosTheta*control.z;

  Number3D result = new Number3D(x,y,z);

  result.add(offset);

  return result;
}

class Number3D {
  public float x=0;
  public float y=0;
  public float z=0;
  public Number3D next;

  public Number3D(float a,float b,float c) {
    this.x = a;
    this.y = b;
    this.z = c;
  }

  public void copyFrom(Number3D toCopy) {
    this.x = toCopy.x;
    this.y = toCopy.y;
    this.z = toCopy.z;
  }

  public void invert() {
    this.x = -this.x;
    this.y = -this.y;
    this.z = -this.z;
  }                      

  public void reset() {
    this.x = 0;
    this.y = 0;
    this.z = 0;
  }

  public void sub(Number3D v) {
    this.x -= v.x;
    this.y -= v.y;
    this.z -= v.z;
  }

  public void add(Number3D v) {
    this.x += v.x;
    this.y += v.y;
    this.z += v.z;
  }

  public void normalize(Number3D v) {
    float m  = sqrt((v.x * v.x) + (v.y * v.y) + (v.z * v.z));

    this.x = v.x/m;
    this.y = v.y/m;
    this.z = v.z/m;
  }
}


public Quaternion quat_mult(Quaternion q1, Quaternion q2) {

  float a = (q1.a*q2.a - q1.b*q2.b - q1.c*q2.c - q1.d*q2.d);
  float b = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float c = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float d = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  Quaternion result = new Quaternion(a,b,c,d);
  return result;
}

// Quaternion multiplication without the .a component
public Number3D quat_pointmult( Quaternion q1, Quaternion q2) {
  float x = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float y = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float z = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  Number3D result = new Number3D(x,y,z);
  return result;
}


class Quaternion {
  public float a = 0;
  public float b = 0;
  public float c = 0;
  public float d = 1;

  public Quaternion(float aa,float bb,float cc,float dd) {
    this.a = aa;
    this.b = bb;
    this.c = cc;
    this.d = dd;
  }
}


class Segment {

  public Number3D offset;
  public Number3D axis;
  public Number3D control;

  public Number3D storedOffset;
  public Number3D storedAxis;
  public Number3D storedControl;

  public int seed;

  public float angle;

  public int totalLines = 50;

  public Number3D[] orbit = new Number3D[totalLines];

  int from = color(255, 0, 102);
  int to = color(0, 102, 153);
  public Segment() {

    reset();
  }

  public void reset() {


    int radius = 100;

    axis 	= new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );
    offset 	= new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );
    control     = new Number3D( random(-radius,radius), random(-radius,radius),	random(-radius,radius) );

    /*
		int radiusA = 50;
     		int radiusB = 100;
     
     		offset 	= new Number3D( 0,0,0 );
     		axis 	= new Number3D( random(radiusA), random(radiusA),	random(radiusA) );
     		control = new Number3D( random(radiusB), random(radiusB),	random(radiusB) );
     		*/

    // axis 	= new Number3D( 50, 0, 0 );
    // offset 	= new Number3D( 0, 0, 0 );
    // control = new Number3D( 0, random(radius)+25, 0 );



    storedAxis = copyFrom2(axis);
    storedOffset = copyFrom2(offset);
    storedControl = copyFrom2(control);
    // angle 	= float(random(360)); 	// in degrees
  }

  public void parse() {
    for(int i=0;i<totalLines;i++) {
      angle = 360*PApplet.parseFloat(i)/PApplet.parseFloat(totalLines) + frameCount*(seed+1)*.125f;
      // angle = 360*float(i)/float(totalLines);
      orbit[i] = rotateAroundArbitraryAxis( offset, control, axis, angle );
    }
  }

  public void draw() {

    drawWidthArray(orbit,0xffFFFFFF);
    // drawPoint(axis,2,#FFFFFF);
    // drawLine(axis,offset,1,#FFFFFF);
  }

  public void drawWidthArray(Number3D[] orbiter, int colorParam) {


    Number3D curr = new Number3D(0,0,0);
    Number3D prev = new Number3D(0,0,0);  
    int lines = orbiter.length;
    float percentage;
    strokeWeight(1);
    float colorShifter = sin( ((PApplet.parseFloat(seed) / PApplet.parseFloat(totalSegments) + frameCount*.001f) * TWO_PI))*.5f+.5f;
    int interColor = lerpColor(from, to,  colorShifter);
    
    for(int i=1;i<lines;i++) {
      curr.copyFrom(orbiter[i]);
      prev.copyFrom(orbiter[i-1]);

      percentage = (PApplet.parseFloat(i)/PApplet.parseFloat(lines)) * 255;

      noStroke();
      fill(interColor, percentage);
      beginShape(TRIANGLE_FAN);
      vertex(prev.x,prev.y,prev.z);
      vertex(curr.x,curr.y,curr.z);
      vertex(offset.x,offset.y,offset.z);
      vertex(prev.x,prev.y,prev.z);
      endShape();



      // stroke(#FF0000,51);
      // line(0,0,0, curr.x,curr.y,curr.z);
    }
  }

  public void drawPoint(Number3D pointParam, int strokeParam, int colorParam) {
    strokeWeight(strokeParam);
    stroke(colorParam,255);
    point( pointParam.x,pointParam.y,pointParam.z);
  }

  public void drawLine(Number3D pointAParam,Number3D pointBParam, int strokeParam, int colorParam) {
    strokeWeight(strokeParam);
    stroke(colorParam,102);
    line( pointAParam.x,pointAParam.y,pointAParam.z,pointBParam.x,pointBParam.y,pointBParam.z);
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "Umbrella" });
  }
}
