import processing.opengl.*;

import peasy.*;

PeasyCam cam;

float axis_X = 0;
float axis_Y = 50;
float axis_Z = 0;

float control_X = 100;
float control_Y = 100;
float control_Z = 0;

float offset_X = 0;
float offset_Y = 100;
float offset_Z = 0;

int totalSegments = 40;

Number3D[] orbit = new Number3D[totalSegments];
Segment[] segments = new Segment[totalSegments];

void setup() {
 size(1200,800,OPENGL); 
  
	cam = new PeasyCam(this, 1000);
	cam.setMinimumDistance(50);
	cam.setMaximumDistance(2000);
	
	
	    // --------------------------------------------------------------------
    // parse data
    // --------------------------------------------------------------------
    int offset;
    int id = 0;
    float absMax = 100;

    offset = 10;

	for(int i=0;i<totalSegments;i++){
		segments[i] = new Segment();
		segments[i].seed = i;
	}
	
}
void draw() {
	
	background(0);
	
	drawAxes(400);
	
	// --------------------------------------------------------------------
	// draw base 
	// --------------------------------------------------------------------
	background(0);
	// drawAxes(400);
	Number3D sumOffset = new Number3D(0,0,0);
	Number3D sumAxis = new Number3D(0,0,0);
	float angleX,angleY;
	
	int i,j,k;
	float percentage;

	segments[0].offset = new Number3D(offset_X,offset_Y,offset_Z);
	segments[0].axis = new Number3D(axis_X,axis_Y,axis_Z);
	
	sumOffset = segments[0].offset;
	sumAxis = segments[0].axis;
	segments[0].parse();

	for(i=1;i<totalSegments;i++){
		
		segments[i].offset = copyFrom2(segments[i-1].axis);
		segments[i].control = add2(segments[i].storedControl, segments[i].offset);
		segments[i].axis = add2(segments[i].storedAxis, segments[i].offset);
		
		angleX = frameCount*(1-float(i)/float(totalSegments));
		angleY = frameCount*(float(i)/float(totalSegments)); 
		
		segments[i].axis = rotateAroundYAxis(segments[i].offset,segments[i].axis,angleX);
		segments[i].axis = rotateAroundXAxis(segments[i].offset,segments[i].axis,angleY);
		
		segments[i].parse();
		segments[i].draw();

	}
	
	/*
	strokeWeight(1);
	for(i=0;i<segments[0].totalLines;i++){
		for(j=1;j<totalSegments;j++){
			
			percentage = (1-float(i+1)/float(30)) * 255;
			drawLine( segments[j].orbit[i] ,segments[j-1].orbit[i], 1, #FFFFFF ,percentage);
		}
	
	}
*/
	
	
	// --------------------------------------------------------------------
	// parse data
	// --------------------------------------------------------------------
	
	// --------------------------------------------------------------------
	// draw data
	// --------------------------------------------------------------------
	
	noFill();

}
void drawLine(Number3D pointAParam,Number3D pointBParam, int strokeParam, color colorParam, float alphaParam){
	strokeWeight(strokeParam);
	stroke(colorParam,alphaParam);
	line( pointAParam.x,pointAParam.y,pointAParam.z ,pointBParam.x,pointBParam.y,pointBParam.z);
}

void drawAxes(float radius) {
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0,255);
  line(0, 0, 0, radius, 0, 0);
  stroke(0, 255, 0,255);
  line(0, 0, 0, 0, radius, 0);
  stroke(0, 0, 255,255);
  line(0, 0, 0, 0, 0, radius);

  stroke(#00FF00,51);
  pushMatrix();
  translate(0, radius,0);
  box(10);
  popMatrix();             

  stroke(#FF0000,51);
  pushMatrix();
  translate(radius, 0,0);
  box(10);
  popMatrix(); 

  stroke(#0000FF,51);
  pushMatrix();
  translate(0, 0,radius);
  box(10);
  popMatrix(); 

  stroke(#FFFFFF,51);
  ellipse(0, 0, 200, 200);

  stroke(#FFFFFF,51);
  box(radius*2);
}

